/*
 ============================================================================
 Name		: CenRepObserver.h
 Author	  : Usanov-Kornilov Nikolay (aka Kolay)
 Version	 : 1.0
 Copyright   : 
 Contacts:
 kolayuk@mail.ru
 http://kolaysoft.ru

 (c) KolaySoft, 2010

 Description : CCenRepObserverS declaration
 ============================================================================
 */

#ifndef CENREPOBSERVERS_H
#define CENREPOBSERVERS_H

// INCLUDES
#include <e32std.h>
#include <e32base.h>
#include "SysApAppUi.h"

class CRepository; //forward declaration
class CSysApAppUi;
//a observer interface for profile change
//These active objects observe the changing of the profile
//and notify the observer when the change has occured
class CCenRepObserverS : public CActive
       {
       public:
               static CCenRepObserverS* NewL( CSysApAppUi& aObserver);
               static CCenRepObserverS* NewLC(CSysApAppUi& aObserver);
                void StartObservingL();
                void StopObserving();
                virtual ~CCenRepObserverS();
                void RunL();
                void RunErrorL(TInt aError);
                void DoCancel();
                CCenRepObserverS(CSysApAppUi& aObserver);
                void ConstructL(TInt aKey, TDesC16& aDefault);
       private:
              CRepository*  iRepository;
              TUint32       iKey;
              TUid          iUid;
              CSysApAppUi&  iObserver; //class using the observer
        };
#endif // CENREPOBSERVER_H
