/*
* Copyright (c) 2007-2010 Nokia Corporation and/or its subsidiary(-ies). 
* All rights reserved.
* This component and the accompanying materials are made available
* under the terms of "Eclipse Public License v1.0"
* which accompanies this distribution, and is available
* at the URL "http://www.eclipse.org/legal/epl-v10.html".
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Implementation of observer class for remote control keys
*
*/


// INCLUDE FILES
#include <remconcoreapitarget.h>
#include <remconinterfaceselector.h>
#include <aknconsts.h>
#include "sysapremconobserver.h"
#include "SysApAppUi.h"
#include <hwrmfmtx.h>

// ============================ MEMBER FUNCTIONS ===============================

// -----------------------------------------------------------------------------
// CSysApRemConObserver::CSysApRemConObserver
// C++ default constructor can NOT contain any code, that
// might leave.
// -----------------------------------------------------------------------------
//
CSysApRemConObserver::CSysApRemConObserver( CSysApAppUi& aSysApAppUi ) 
 : iInterfaceSelector( NULL ),
   iCoreTarget( NULL ),
   iSysApAppUi( aSysApAppUi )
    {
    // Nothing
    }

// -----------------------------------------------------------------------------
// CSysApRemConObserver::ConstructL
// Symbian 2nd phase constructor can leave.
// -----------------------------------------------------------------------------
//
void CSysApRemConObserver::ConstructL()
    {
     //  
    }

// -----------------------------------------------------------------------------
// CSysApRemConObserver::NewL
// Two-phased constructor.
// -----------------------------------------------------------------------------
//
CSysApRemConObserver* CSysApRemConObserver::NewL( CSysApAppUi& aSysApAppUi )
    {   
     //
    
    CSysApRemConObserver* self = new( ELeave ) CSysApRemConObserver( aSysApAppUi );
    
    CleanupStack::PushL( self );
    self->ConstructL();
    CleanupStack::Pop( self );

    return self;
    }

// -----------------------------------------------------------------------------
// CSysApRemConObserver::~CSysApRemConObserver
// Destructor
// -----------------------------------------------------------------------------
//
CSysApRemConObserver::~CSysApRemConObserver()
    {
     //
    }
    
// -----------------------------------------------------------------------------
// CSysApRemConObserver::MrccatoCommand
// Handles remote key event
// -----------------------------------------------------------------------------
//
void CSysApRemConObserver::MrccatoCommand( TRemConCoreApiOperationId aOperationId, 
                                        TRemConCoreApiButtonAction aButtonAct )
	{
    if (iSysApAppUi.iSysap2SetActive)
    {
    TInt xFmTxSets;
    iSysApAppUi.iSysap2SetRepo->Get(4, xFmTxSets);
    iSysApAppUi.ValueChanged(4, xFmTxSets); 
    
    //TInt xAnyKeyAnswer;
    //iSysApAppUi.iSysap2SetRepo->Get(7, xAnyKeyAnswer);
    //iSysApAppUi.ValueChanged(7, xAnyKeyAnswer);
    }
    /*
    TInt fmTxState;
    TInt callState;
    const TUid KPSUidHWRMFmTx = {0x101F7A02};
    RProperty::Get( KPSUidHWRMFmTx, 1, fmTxState );
    const TUid KPSUidCtsyCallInformation = {0x102029AC};
    RProperty::Get( KPSUidCtsyCallInformation, 1, callState );
    
    //if (iSysApAppUi.iAnyKeyAnswer && (callState == 3))
    //if ((aButtonAct == ERemConCoreApiButtonPress || aButtonAct == ERemConCoreApiButtonClick) && callState == 3)
    	{
		TRawEvent lEvent;
		lEvent.Set(TRawEvent::EKeyDown, 0xc4);
		UserSvr::AddEvent(lEvent);
		lEvent.Set(TRawEvent::EKeyUp, 0xc4);
		UserSvr::AddEvent(lEvent); 
    	}    	*/

	if (  (aButtonAct == ERemConCoreApiButtonPress || aButtonAct == ERemConCoreApiButtonClick) && (iSysApAppUi.iFmTxVolumeDisabledNoteActive) )
	    {
	    if ( aOperationId == ERemConCoreApiVolumeUp 
	        || aOperationId == ERemConCoreApiVolumeDown
	        || aOperationId == ERemConCoreApiMute )
	        {
            // A volume key is pressed down
	    	TRAPD( err, iSysApAppUi.ShowUiNoteL( EFmTxVolumeDisabledNote ) );
            
            if ( err != KErrNone )
                {
                 //
                }
	        }
	    }
	}

/**
 * Reserve the volume keys
 */
void CSysApRemConObserver::StartRemconInterface()
    {
     //
    if(!iInterfaceSelector)
        {
        iInterfaceSelector = CRemConInterfaceSelector::NewL();
        iCoreTarget = CRemConCoreApiTarget::NewL( *iInterfaceSelector, *this );
        iInterfaceSelector->OpenTargetL();
        }
    }

/**
 * Release the volume keys for other application like phone app during call
 */
void CSysApRemConObserver::StopRemconInterface()
    {
     //
    if(iInterfaceSelector)
        {
        delete iInterfaceSelector;
        iInterfaceSelector = NULL;
        }
    }

//  End of File 
